/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from fractional-scale-v1.xml by mir_wayland_generator
 */

#include "fractional-scale-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_surface_interface_data;
extern struct wl_interface const wp_fractional_scale_manager_v1_interface_data;
extern struct wl_interface const wp_fractional_scale_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// FractionalScaleManagerV1

struct mw::FractionalScaleManagerV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<FractionalScaleManagerV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "FractionalScaleManagerV1::destroy()");
        }
    }

    static void get_fractional_scale_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &wp_fractional_scale_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<FractionalScaleManagerV1*>(wl_resource_get_user_data(resource));
            me->get_fractional_scale(id_resolved, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "FractionalScaleManagerV1::get_fractional_scale()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<FractionalScaleManagerV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<FractionalScaleManagerV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &wp_fractional_scale_manager_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "FractionalScaleManagerV1 global bind");
        }
    }

    static struct wl_interface const* get_fractional_scale_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::FractionalScaleManagerV1::Thunks::supported_version = 1;

mw::FractionalScaleManagerV1::FractionalScaleManagerV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::FractionalScaleManagerV1::~FractionalScaleManagerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::FractionalScaleManagerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &wp_fractional_scale_manager_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::FractionalScaleManagerV1::Error::fractional_scale_exists;

mw::FractionalScaleManagerV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &wp_fractional_scale_manager_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::FractionalScaleManagerV1::Global::interface_name() const -> char const*
{
    return FractionalScaleManagerV1::interface_name;
}

struct wl_interface const* mw::FractionalScaleManagerV1::Thunks::get_fractional_scale_types[] {
    &wp_fractional_scale_v1_interface_data,
    &wl_surface_interface_data};

struct wl_message const mw::FractionalScaleManagerV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"get_fractional_scale", "no", get_fractional_scale_types}};

void const* mw::FractionalScaleManagerV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::get_fractional_scale_thunk};

mw::FractionalScaleManagerV1* mw::FractionalScaleManagerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &wp_fractional_scale_manager_v1_interface_data, FractionalScaleManagerV1::Thunks::request_vtable))
    {
        return static_cast<FractionalScaleManagerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// FractionalScaleV1

struct mw::FractionalScaleV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<FractionalScaleV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "FractionalScaleV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<FractionalScaleV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::FractionalScaleV1::Thunks::supported_version = 1;

mw::FractionalScaleV1::FractionalScaleV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::FractionalScaleV1::~FractionalScaleV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::FractionalScaleV1::send_preferred_scale_event(uint32_t scale) const
{
    wl_resource_post_event(resource, Opcode::preferred_scale, scale);
}

bool mw::FractionalScaleV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &wp_fractional_scale_v1_interface_data, Thunks::request_vtable);
}

struct wl_message const mw::FractionalScaleV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types}};

struct wl_message const mw::FractionalScaleV1::Thunks::event_messages[] {
    {"preferred_scale", "u", all_null_types}};

void const* mw::FractionalScaleV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk};

mw::FractionalScaleV1* mw::FractionalScaleV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &wp_fractional_scale_v1_interface_data, FractionalScaleV1::Thunks::request_vtable))
    {
        return static_cast<FractionalScaleV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const wp_fractional_scale_manager_v1_interface_data {
    mw::FractionalScaleManagerV1::interface_name,
    mw::FractionalScaleManagerV1::Thunks::supported_version,
    2, mw::FractionalScaleManagerV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const wp_fractional_scale_v1_interface_data {
    mw::FractionalScaleV1::interface_name,
    mw::FractionalScaleV1::Thunks::supported_version,
    1, mw::FractionalScaleV1::Thunks::request_messages,
    1, mw::FractionalScaleV1::Thunks::event_messages};

}
}
