/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from mir-shell-unstable-v1.xml by mir_wayland_generator
 */

#include "mir-shell-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const mir_dialog_surface_v1_interface_data;
extern struct wl_interface const mir_floating_regular_surface_v1_interface_data;
extern struct wl_interface const mir_positioner_v1_interface_data;
extern struct wl_interface const mir_regular_surface_v1_interface_data;
extern struct wl_interface const mir_satellite_surface_v1_interface_data;
extern struct wl_interface const mir_shell_v1_interface_data;
extern struct wl_interface const wl_surface_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// MirShellV1

struct mw::MirShellV1::Thunks
{
    static int const supported_version;

    static void get_regular_surface_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &mir_regular_surface_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
            me->get_regular_surface(id_resolved, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirShellV1::get_regular_surface()");
        }
    }

    static void get_floating_regular_surface_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &mir_floating_regular_surface_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
            me->get_floating_regular_surface(id_resolved, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirShellV1::get_floating_regular_surface()");
        }
    }

    static void get_dialog_surface_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &mir_dialog_surface_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
            me->get_dialog_surface(id_resolved, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirShellV1::get_dialog_surface()");
        }
    }

    static void get_satellite_surface_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface, struct wl_resource* positioner)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &mir_satellite_surface_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
            me->get_satellite_surface(id_resolved, surface, positioner);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirShellV1::get_satellite_surface()");
        }
    }

    static void create_positioner_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &mir_positioner_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
            me->create_positioner(id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirShellV1::create_positioner()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirShellV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<MirShellV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &mir_shell_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirShellV1 global bind");
        }
    }

    static struct wl_interface const* get_regular_surface_types[];
    static struct wl_interface const* get_floating_regular_surface_types[];
    static struct wl_interface const* get_dialog_surface_types[];
    static struct wl_interface const* get_satellite_surface_types[];
    static struct wl_interface const* create_positioner_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::MirShellV1::Thunks::supported_version = 1;

mw::MirShellV1::MirShellV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::MirShellV1::~MirShellV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::MirShellV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &mir_shell_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::MirShellV1::Error::archetype;

mw::MirShellV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &mir_shell_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::MirShellV1::Global::interface_name() const -> char const*
{
    return MirShellV1::interface_name;
}

struct wl_interface const* mw::MirShellV1::Thunks::get_regular_surface_types[] {
    &mir_regular_surface_v1_interface_data,
    &wl_surface_interface_data};

struct wl_interface const* mw::MirShellV1::Thunks::get_floating_regular_surface_types[] {
    &mir_floating_regular_surface_v1_interface_data,
    &wl_surface_interface_data};

struct wl_interface const* mw::MirShellV1::Thunks::get_dialog_surface_types[] {
    &mir_dialog_surface_v1_interface_data,
    &wl_surface_interface_data};

struct wl_interface const* mw::MirShellV1::Thunks::get_satellite_surface_types[] {
    &mir_satellite_surface_v1_interface_data,
    &wl_surface_interface_data,
    &mir_positioner_v1_interface_data};

struct wl_interface const* mw::MirShellV1::Thunks::create_positioner_types[] {
    &mir_positioner_v1_interface_data};

struct wl_message const mw::MirShellV1::Thunks::request_messages[] {
    {"get_regular_surface", "no", get_regular_surface_types},
    {"get_floating_regular_surface", "no", get_floating_regular_surface_types},
    {"get_dialog_surface", "no", get_dialog_surface_types},
    {"get_satellite_surface", "noo", get_satellite_surface_types},
    {"create_positioner", "n", create_positioner_types},
    {"destroy", "", all_null_types}};

void const* mw::MirShellV1::Thunks::request_vtable[] {
    (void*)Thunks::get_regular_surface_thunk,
    (void*)Thunks::get_floating_regular_surface_thunk,
    (void*)Thunks::get_dialog_surface_thunk,
    (void*)Thunks::get_satellite_surface_thunk,
    (void*)Thunks::create_positioner_thunk,
    (void*)Thunks::destroy_thunk};

mw::MirShellV1* mw::MirShellV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &mir_shell_v1_interface_data, MirShellV1::Thunks::request_vtable))
    {
        return static_cast<MirShellV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// MirRegularSurfaceV1

struct mw::MirRegularSurfaceV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<MirRegularSurfaceV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirRegularSurfaceV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<MirRegularSurfaceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::MirRegularSurfaceV1::Thunks::supported_version = 1;

mw::MirRegularSurfaceV1::MirRegularSurfaceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::MirRegularSurfaceV1::~MirRegularSurfaceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::MirRegularSurfaceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &mir_regular_surface_v1_interface_data, Thunks::request_vtable);
}

struct wl_message const mw::MirRegularSurfaceV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types}};

void const* mw::MirRegularSurfaceV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk};

mw::MirRegularSurfaceV1* mw::MirRegularSurfaceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &mir_regular_surface_v1_interface_data, MirRegularSurfaceV1::Thunks::request_vtable))
    {
        return static_cast<MirRegularSurfaceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// MirFloatingRegularSurfaceV1

struct mw::MirFloatingRegularSurfaceV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<MirFloatingRegularSurfaceV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirFloatingRegularSurfaceV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<MirFloatingRegularSurfaceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::MirFloatingRegularSurfaceV1::Thunks::supported_version = 1;

mw::MirFloatingRegularSurfaceV1::MirFloatingRegularSurfaceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::MirFloatingRegularSurfaceV1::~MirFloatingRegularSurfaceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::MirFloatingRegularSurfaceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &mir_floating_regular_surface_v1_interface_data, Thunks::request_vtable);
}

struct wl_message const mw::MirFloatingRegularSurfaceV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types}};

void const* mw::MirFloatingRegularSurfaceV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk};

mw::MirFloatingRegularSurfaceV1* mw::MirFloatingRegularSurfaceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &mir_floating_regular_surface_v1_interface_data, MirFloatingRegularSurfaceV1::Thunks::request_vtable))
    {
        return static_cast<MirFloatingRegularSurfaceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// MirDialogSurfaceV1

struct mw::MirDialogSurfaceV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<MirDialogSurfaceV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirDialogSurfaceV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<MirDialogSurfaceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::MirDialogSurfaceV1::Thunks::supported_version = 1;

mw::MirDialogSurfaceV1::MirDialogSurfaceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::MirDialogSurfaceV1::~MirDialogSurfaceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::MirDialogSurfaceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &mir_dialog_surface_v1_interface_data, Thunks::request_vtable);
}

struct wl_message const mw::MirDialogSurfaceV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types}};

void const* mw::MirDialogSurfaceV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk};

mw::MirDialogSurfaceV1* mw::MirDialogSurfaceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &mir_dialog_surface_v1_interface_data, MirDialogSurfaceV1::Thunks::request_vtable))
    {
        return static_cast<MirDialogSurfaceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// MirSatelliteSurfaceV1

struct mw::MirSatelliteSurfaceV1::Thunks
{
    static int const supported_version;

    static void reposition_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* positioner, uint32_t token)
    {
        try
        {
            auto me = static_cast<MirSatelliteSurfaceV1*>(wl_resource_get_user_data(resource));
            me->reposition(positioner, token);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirSatelliteSurfaceV1::reposition()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<MirSatelliteSurfaceV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirSatelliteSurfaceV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<MirSatelliteSurfaceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* reposition_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::MirSatelliteSurfaceV1::Thunks::supported_version = 1;

mw::MirSatelliteSurfaceV1::MirSatelliteSurfaceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::MirSatelliteSurfaceV1::~MirSatelliteSurfaceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::MirSatelliteSurfaceV1::send_repositioned_event(uint32_t token) const
{
    wl_resource_post_event(resource, Opcode::repositioned, token);
}

bool mw::MirSatelliteSurfaceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &mir_satellite_surface_v1_interface_data, Thunks::request_vtable);
}

struct wl_interface const* mw::MirSatelliteSurfaceV1::Thunks::reposition_types[] {
    &mir_positioner_v1_interface_data,
    nullptr};

struct wl_message const mw::MirSatelliteSurfaceV1::Thunks::request_messages[] {
    {"reposition", "ou", reposition_types},
    {"destroy", "", all_null_types}};

struct wl_message const mw::MirSatelliteSurfaceV1::Thunks::event_messages[] {
    {"repositioned", "u", all_null_types}};

void const* mw::MirSatelliteSurfaceV1::Thunks::request_vtable[] {
    (void*)Thunks::reposition_thunk,
    (void*)Thunks::destroy_thunk};

mw::MirSatelliteSurfaceV1* mw::MirSatelliteSurfaceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &mir_satellite_surface_v1_interface_data, MirSatelliteSurfaceV1::Thunks::request_vtable))
    {
        return static_cast<MirSatelliteSurfaceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// MirPositionerV1

struct mw::MirPositionerV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirPositionerV1::destroy()");
        }
    }

    static void set_size_thunk(struct wl_client* client, struct wl_resource* resource, int32_t width, int32_t height)
    {
        try
        {
            auto me = static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
            me->set_size(width, height);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirPositionerV1::set_size()");
        }
    }

    static void set_anchor_rect_thunk(struct wl_client* client, struct wl_resource* resource, int32_t x, int32_t y, int32_t width, int32_t height)
    {
        try
        {
            auto me = static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
            me->set_anchor_rect(x, y, width, height);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirPositionerV1::set_anchor_rect()");
        }
    }

    static void set_anchor_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t anchor)
    {
        try
        {
            auto me = static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
            me->set_anchor(anchor);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirPositionerV1::set_anchor()");
        }
    }

    static void set_gravity_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t gravity)
    {
        try
        {
            auto me = static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
            me->set_gravity(gravity);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirPositionerV1::set_gravity()");
        }
    }

    static void set_constraint_adjustment_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t constraint_adjustment)
    {
        try
        {
            auto me = static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
            me->set_constraint_adjustment(constraint_adjustment);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirPositionerV1::set_constraint_adjustment()");
        }
    }

    static void set_offset_thunk(struct wl_client* client, struct wl_resource* resource, int32_t x, int32_t y)
    {
        try
        {
            auto me = static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
            me->set_offset(x, y);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "MirPositionerV1::set_offset()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::MirPositionerV1::Thunks::supported_version = 1;

mw::MirPositionerV1::MirPositionerV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::MirPositionerV1::~MirPositionerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::MirPositionerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &mir_positioner_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::MirPositionerV1::Error::invalid_input;
uint32_t const mw::MirPositionerV1::Anchor::none;
uint32_t const mw::MirPositionerV1::Anchor::top;
uint32_t const mw::MirPositionerV1::Anchor::bottom;
uint32_t const mw::MirPositionerV1::Anchor::left;
uint32_t const mw::MirPositionerV1::Anchor::right;
uint32_t const mw::MirPositionerV1::Anchor::top_left;
uint32_t const mw::MirPositionerV1::Anchor::bottom_left;
uint32_t const mw::MirPositionerV1::Anchor::top_right;
uint32_t const mw::MirPositionerV1::Anchor::bottom_right;
uint32_t const mw::MirPositionerV1::Gravity::none;
uint32_t const mw::MirPositionerV1::Gravity::top;
uint32_t const mw::MirPositionerV1::Gravity::bottom;
uint32_t const mw::MirPositionerV1::Gravity::left;
uint32_t const mw::MirPositionerV1::Gravity::right;
uint32_t const mw::MirPositionerV1::Gravity::top_left;
uint32_t const mw::MirPositionerV1::Gravity::bottom_left;
uint32_t const mw::MirPositionerV1::Gravity::top_right;
uint32_t const mw::MirPositionerV1::Gravity::bottom_right;
uint32_t const mw::MirPositionerV1::ConstraintAdjustment::none;
uint32_t const mw::MirPositionerV1::ConstraintAdjustment::slide_x;
uint32_t const mw::MirPositionerV1::ConstraintAdjustment::slide_y;
uint32_t const mw::MirPositionerV1::ConstraintAdjustment::flip_x;
uint32_t const mw::MirPositionerV1::ConstraintAdjustment::flip_y;
uint32_t const mw::MirPositionerV1::ConstraintAdjustment::resize_x;
uint32_t const mw::MirPositionerV1::ConstraintAdjustment::resize_y;

struct wl_message const mw::MirPositionerV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"set_size", "ii", all_null_types},
    {"set_anchor_rect", "iiii", all_null_types},
    {"set_anchor", "u", all_null_types},
    {"set_gravity", "u", all_null_types},
    {"set_constraint_adjustment", "u", all_null_types},
    {"set_offset", "ii", all_null_types}};

void const* mw::MirPositionerV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::set_size_thunk,
    (void*)Thunks::set_anchor_rect_thunk,
    (void*)Thunks::set_anchor_thunk,
    (void*)Thunks::set_gravity_thunk,
    (void*)Thunks::set_constraint_adjustment_thunk,
    (void*)Thunks::set_offset_thunk};

mw::MirPositionerV1* mw::MirPositionerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &mir_positioner_v1_interface_data, MirPositionerV1::Thunks::request_vtable))
    {
        return static_cast<MirPositionerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const mir_shell_v1_interface_data {
    mw::MirShellV1::interface_name,
    mw::MirShellV1::Thunks::supported_version,
    6, mw::MirShellV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const mir_regular_surface_v1_interface_data {
    mw::MirRegularSurfaceV1::interface_name,
    mw::MirRegularSurfaceV1::Thunks::supported_version,
    1, mw::MirRegularSurfaceV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const mir_floating_regular_surface_v1_interface_data {
    mw::MirFloatingRegularSurfaceV1::interface_name,
    mw::MirFloatingRegularSurfaceV1::Thunks::supported_version,
    1, mw::MirFloatingRegularSurfaceV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const mir_dialog_surface_v1_interface_data {
    mw::MirDialogSurfaceV1::interface_name,
    mw::MirDialogSurfaceV1::Thunks::supported_version,
    1, mw::MirDialogSurfaceV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const mir_satellite_surface_v1_interface_data {
    mw::MirSatelliteSurfaceV1::interface_name,
    mw::MirSatelliteSurfaceV1::Thunks::supported_version,
    2, mw::MirSatelliteSurfaceV1::Thunks::request_messages,
    1, mw::MirSatelliteSurfaceV1::Thunks::event_messages};

struct wl_interface const mir_positioner_v1_interface_data {
    mw::MirPositionerV1::interface_name,
    mw::MirPositionerV1::Thunks::supported_version,
    7, mw::MirPositionerV1::Thunks::request_messages,
    0, nullptr};

}
}
