/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from mir-shell-unstable-v1.xml by mir_wayland_generator
 */

#ifndef MIR_FRONTEND_WAYLAND_MIR_SHELL_UNSTABLE_V1_XML_WRAPPER
#define MIR_FRONTEND_WAYLAND_MIR_SHELL_UNSTABLE_V1_XML_WRAPPER

#include <optional>

#include "mir/fd.h"
#include <wayland-server-core.h>

#include "mir/wayland/resource.h"
#include "mir/wayland/global.h"

namespace mir
{
namespace wayland
{

class MirShellV1;
class MirRegularSurfaceV1;
class MirFloatingRegularSurfaceV1;
class MirDialogSurfaceV1;
class MirSatelliteSurfaceV1;
class MirPositionerV1;

class MirShellV1 : public Resource
{
public:
    static char const constexpr* interface_name = "mir_shell_v1";

    static MirShellV1* from(struct wl_resource*);

    MirShellV1(struct wl_resource* resource, Version<1>);
    virtual ~MirShellV1();

    struct Error
    {
        static uint32_t const archetype = 0;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

    class Global : public wayland::Global
    {
    public:
        Global(wl_display* display, Version<1>);

        auto interface_name() const -> char const* override;

    private:
        virtual void bind(wl_resource* new_mir_shell_v1) = 0;
        friend MirShellV1::Thunks;
    };

private:
    virtual void get_regular_surface(struct wl_resource* id, struct wl_resource* surface) = 0;
    virtual void get_floating_regular_surface(struct wl_resource* id, struct wl_resource* surface) = 0;
    virtual void get_dialog_surface(struct wl_resource* id, struct wl_resource* surface) = 0;
    virtual void get_satellite_surface(struct wl_resource* id, struct wl_resource* surface, struct wl_resource* positioner) = 0;
    virtual void create_positioner(struct wl_resource* id) = 0;
    virtual void destroy() {}
};

class MirRegularSurfaceV1 : public Resource
{
public:
    static char const constexpr* interface_name = "mir_regular_surface_v1";

    static MirRegularSurfaceV1* from(struct wl_resource*);

    MirRegularSurfaceV1(struct wl_resource* resource, Version<1>);
    virtual ~MirRegularSurfaceV1();

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void destroy() {}
};

class MirFloatingRegularSurfaceV1 : public Resource
{
public:
    static char const constexpr* interface_name = "mir_floating_regular_surface_v1";

    static MirFloatingRegularSurfaceV1* from(struct wl_resource*);

    MirFloatingRegularSurfaceV1(struct wl_resource* resource, Version<1>);
    virtual ~MirFloatingRegularSurfaceV1();

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void destroy() {}
};

class MirDialogSurfaceV1 : public Resource
{
public:
    static char const constexpr* interface_name = "mir_dialog_surface_v1";

    static MirDialogSurfaceV1* from(struct wl_resource*);

    MirDialogSurfaceV1(struct wl_resource* resource, Version<1>);
    virtual ~MirDialogSurfaceV1();

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void destroy() {}
};

class MirSatelliteSurfaceV1 : public Resource
{
public:
    static char const constexpr* interface_name = "mir_satellite_surface_v1";

    static MirSatelliteSurfaceV1* from(struct wl_resource*);

    MirSatelliteSurfaceV1(struct wl_resource* resource, Version<1>);
    virtual ~MirSatelliteSurfaceV1();

    void send_repositioned_event(uint32_t token) const;

    struct Opcode
    {
        static uint32_t const repositioned = 0;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void reposition(struct wl_resource* positioner, uint32_t token) = 0;
    virtual void destroy() {}
};

class MirPositionerV1 : public Resource
{
public:
    static char const constexpr* interface_name = "mir_positioner_v1";

    static MirPositionerV1* from(struct wl_resource*);

    MirPositionerV1(struct wl_resource* resource, Version<1>);
    virtual ~MirPositionerV1();

    struct Error
    {
        static uint32_t const invalid_input = 0;
    };

    struct Anchor
    {
        static uint32_t const none = 0;
        static uint32_t const top = 1;
        static uint32_t const bottom = 2;
        static uint32_t const left = 3;
        static uint32_t const right = 4;
        static uint32_t const top_left = 5;
        static uint32_t const bottom_left = 6;
        static uint32_t const top_right = 7;
        static uint32_t const bottom_right = 8;
    };

    struct Gravity
    {
        static uint32_t const none = 0;
        static uint32_t const top = 1;
        static uint32_t const bottom = 2;
        static uint32_t const left = 3;
        static uint32_t const right = 4;
        static uint32_t const top_left = 5;
        static uint32_t const bottom_left = 6;
        static uint32_t const top_right = 7;
        static uint32_t const bottom_right = 8;
    };

    struct ConstraintAdjustment
    {
        static uint32_t const none = 0;
        static uint32_t const slide_x = 1;
        static uint32_t const slide_y = 2;
        static uint32_t const flip_x = 4;
        static uint32_t const flip_y = 8;
        static uint32_t const resize_x = 16;
        static uint32_t const resize_y = 32;
    };

    struct Thunks;

    static bool is_instance(wl_resource* resource);

private:
    virtual void destroy() {}
    virtual void set_size(int32_t width, int32_t height) = 0;
    virtual void set_anchor_rect(int32_t x, int32_t y, int32_t width, int32_t height) = 0;
    virtual void set_anchor(uint32_t anchor) = 0;
    virtual void set_gravity(uint32_t gravity) = 0;
    virtual void set_constraint_adjustment(uint32_t constraint_adjustment) = 0;
    virtual void set_offset(int32_t x, int32_t y) = 0;
};

}
}

#endif // MIR_FRONTEND_WAYLAND_MIR_SHELL_UNSTABLE_V1_XML_WRAPPER
