/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from xdg-activation-v1.xml by mir_wayland_generator
 */

#include "xdg-activation-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_seat_interface_data;
extern struct wl_interface const wl_surface_interface_data;
extern struct wl_interface const xdg_activation_token_v1_interface_data;
extern struct wl_interface const xdg_activation_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// XdgActivationV1

struct mw::XdgActivationV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<XdgActivationV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationV1::destroy()");
        }
    }

    static void get_activation_token_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &xdg_activation_token_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<XdgActivationV1*>(wl_resource_get_user_data(resource));
            me->get_activation_token(id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationV1::get_activation_token()");
        }
    }

    static void activate_thunk(struct wl_client* client, struct wl_resource* resource, char const* token, struct wl_resource* surface)
    {
        try
        {
            auto me = static_cast<XdgActivationV1*>(wl_resource_get_user_data(resource));
            me->activate(token, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationV1::activate()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<XdgActivationV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<XdgActivationV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &xdg_activation_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationV1 global bind");
        }
    }

    static struct wl_interface const* get_activation_token_types[];
    static struct wl_interface const* activate_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::XdgActivationV1::Thunks::supported_version = 1;

mw::XdgActivationV1::XdgActivationV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::XdgActivationV1::~XdgActivationV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::XdgActivationV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &xdg_activation_v1_interface_data, Thunks::request_vtable);
}

mw::XdgActivationV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &xdg_activation_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::XdgActivationV1::Global::interface_name() const -> char const*
{
    return XdgActivationV1::interface_name;
}

struct wl_interface const* mw::XdgActivationV1::Thunks::get_activation_token_types[] {
    &xdg_activation_token_v1_interface_data};

struct wl_interface const* mw::XdgActivationV1::Thunks::activate_types[] {
    nullptr,
    &wl_surface_interface_data};

struct wl_message const mw::XdgActivationV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"get_activation_token", "n", get_activation_token_types},
    {"activate", "so", activate_types}};

void const* mw::XdgActivationV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::get_activation_token_thunk,
    (void*)Thunks::activate_thunk};

mw::XdgActivationV1* mw::XdgActivationV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &xdg_activation_v1_interface_data, XdgActivationV1::Thunks::request_vtable))
    {
        return static_cast<XdgActivationV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// XdgActivationTokenV1

struct mw::XdgActivationTokenV1::Thunks
{
    static int const supported_version;

    static void set_serial_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial, struct wl_resource* seat)
    {
        try
        {
            auto me = static_cast<XdgActivationTokenV1*>(wl_resource_get_user_data(resource));
            me->set_serial(serial, seat);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationTokenV1::set_serial()");
        }
    }

    static void set_app_id_thunk(struct wl_client* client, struct wl_resource* resource, char const* app_id)
    {
        try
        {
            auto me = static_cast<XdgActivationTokenV1*>(wl_resource_get_user_data(resource));
            me->set_app_id(app_id);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationTokenV1::set_app_id()");
        }
    }

    static void set_surface_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* surface)
    {
        try
        {
            auto me = static_cast<XdgActivationTokenV1*>(wl_resource_get_user_data(resource));
            me->set_surface(surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationTokenV1::set_surface()");
        }
    }

    static void commit_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<XdgActivationTokenV1*>(wl_resource_get_user_data(resource));
            me->commit();
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationTokenV1::commit()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<XdgActivationTokenV1*>(wl_resource_get_user_data(resource));
            me->destroy();
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "XdgActivationTokenV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<XdgActivationTokenV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* set_serial_types[];
    static struct wl_interface const* set_surface_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::XdgActivationTokenV1::Thunks::supported_version = 1;

mw::XdgActivationTokenV1::XdgActivationTokenV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::XdgActivationTokenV1::~XdgActivationTokenV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::XdgActivationTokenV1::send_done_event(std::string const& token) const
{
    const char* token_resolved = token.c_str();
    wl_resource_post_event(resource, Opcode::done, token_resolved);
}

bool mw::XdgActivationTokenV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &xdg_activation_token_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::XdgActivationTokenV1::Error::already_used;

struct wl_interface const* mw::XdgActivationTokenV1::Thunks::set_serial_types[] {
    nullptr,
    &wl_seat_interface_data};

struct wl_interface const* mw::XdgActivationTokenV1::Thunks::set_surface_types[] {
    &wl_surface_interface_data};

struct wl_message const mw::XdgActivationTokenV1::Thunks::request_messages[] {
    {"set_serial", "uo", set_serial_types},
    {"set_app_id", "s", all_null_types},
    {"set_surface", "o", set_surface_types},
    {"commit", "", all_null_types},
    {"destroy", "", all_null_types}};

struct wl_message const mw::XdgActivationTokenV1::Thunks::event_messages[] {
    {"done", "s", all_null_types}};

void const* mw::XdgActivationTokenV1::Thunks::request_vtable[] {
    (void*)Thunks::set_serial_thunk,
    (void*)Thunks::set_app_id_thunk,
    (void*)Thunks::set_surface_thunk,
    (void*)Thunks::commit_thunk,
    (void*)Thunks::destroy_thunk};

mw::XdgActivationTokenV1* mw::XdgActivationTokenV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &xdg_activation_token_v1_interface_data, XdgActivationTokenV1::Thunks::request_vtable))
    {
        return static_cast<XdgActivationTokenV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const xdg_activation_v1_interface_data {
    mw::XdgActivationV1::interface_name,
    mw::XdgActivationV1::Thunks::supported_version,
    3, mw::XdgActivationV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const xdg_activation_token_v1_interface_data {
    mw::XdgActivationTokenV1::interface_name,
    mw::XdgActivationTokenV1::Thunks::supported_version,
    5, mw::XdgActivationTokenV1::Thunks::request_messages,
    1, mw::XdgActivationTokenV1::Thunks::event_messages};

}
}
